unit FtpThread_;

interface

uses
  Classes,SysUtils,IdFTPCommon,Windows,IdGlobal,IdFTPList;

type
  TFtpThread_ = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

implementation

uses Unit1;

{ Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TFtpThread_.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TFtpThread_ }

var
  aURL,aFile:string;

procedure TFtpThread_.Execute;
var
  t : TIdFTPListItem;
  i : integer;
  fileName,foldName : String;
begin
  { Place thread code here }
  //
  form1.IdFTP1.Host     := form1.Edt_FtpIP.Text;
  form1.IdFTP1.Username := form1.Edt_user.Text;
  form1.IdFTP1.Password := form1.Edt_pwd.Text;

  with form1.IdFTP1 do
  try
    if Connected then Disconnect;                      //
      Connect;
  except
    exit;
  end;
  
  if not DirectoryExists(form1.Edt_LocalPath.Text) then     //Ŀ¼򴴽ļ
  begin
    ForceDirectories(form1.Edt_LocalPath.Text);             //һȫ·ļ
  end;
  
  form1.IdFTP1.changedir(form1.Edt_ServerPath.Text);          //ıĿ¼
  form1.IdFTP1.List(nil);                               //ȡǰĿ¼Ϣ
 
  form1.IdFTP1.TransferType := ftBinary;                //ָΪļ   ıļftASCII

  for i:=0 to form1.IdFTP1.DirectoryListing.Count-1 do
  begin
    form1.ThreadState_:=True;
    t := form1.IdFTP1.DirectoryListing.Items[i];        //õһļϢ
    fileName := t.FileName;                      //ȡļ
    if t.ItemType = ditFile then                 //ļֱ
    begin
      form1.ProgressBar1.Max:=form1.IdFTP1.Size(t.FileName);
      form1.ListBox1.Items.Add('أļ'+t.FileName+'ļС'+IntToStr(form1.ProgressBar1.Max));
      
      form1.IdFTP1.Get(fileName,form1.Edt_LocalPath.Text+'\' + fileName,True); //صأΪ
    end;
    
    if i=form1.IdFTP1.DirectoryListing.Count-1 then
      form1.ListBox1.Items.Add('**********ļ**********');
  end;
end;

end.
